var g_cookieName = "upwardedVotes";
var g_req = null;

function populateUserName()
{
    var elm = document.getElementById("userName");
    if (elm) {
        var sName = getCookie("upwardedUserName");
        if (sName != "" && sName != null) {
            if (elm.value == "") {
                elm.value = sName;
            }
        }
    }
}

function upwardIt(itemId, upwardedAt)
{
    var existingVotes = getCookie(g_cookieName);
    if (existingVotes == null) { existingVotes = ""; }
    var arrVotes = existingVotes.split(";");

    var i = 0;
    var alreadyVotedForThis = false;
    for (i = 0; i < arrVotes.length; i++) {
        if (arrVotes[i] == itemId) {
            alreadyVotedForThis = true;
        }
    }

    if (alreadyVotedForThis) {
        setUpwardDisplay(itemId, "Already Upwarded");
    }
    else {
        var newVotes = "";
        if (existingVotes == "") {
            newVotes = itemId;
        }
        else {
            newVotes = existingVotes + ";" + itemId;
        }
        serverSendVote(itemId, upwardedAt);
        setUpwardDisplay(itemId, "Upwarded");
        increaseUpwardsDisplay(itemId);
        setCookie(g_cookieName, newVotes, 120);
    }
}

function increaseUpwardsDisplay(itemId)
{
    var elm = document.getElementById("itemVotes" + itemId);
    if (elm) {
        var n = elm.innerHTML;
        elm.innerHTML = ++n;
    }
}

function serverSendVote(itemId, upwardedAt)
{
    if (g_req == null) {
        var url = "/?mode=vote&" + "itemId=" + escape(itemId) + "&upwardedAt=" + escape(upwardedAt) + getCachePrevent();

        if (window.XMLHttpRequest) {
            g_req = new XMLHttpRequest();
        }
        else if (window.ActiveXObject) {
            g_req = new ActiveXObject("Microsoft.XMLHTTP");
        }
        g_req.onreadystatechange = serverReceiveVote;
        g_req.open("GET", url, true);
        g_req.send(null);
    }
}

function serverReceiveVote()
{
    if (g_req.readyState == 4) {
        if (g_req.status == 200)
        {
            var d = g_req.responseXML.getElementsByTagName("response");

            if (d.length > 0) {
                for (var n = 0; n < d.length; n++) {
                    var sResponse = d[n].firstChild.data;
                    if (sResponse != 'Upwarded') {
                        alert(sResponse);
                    }
                }
            }

            g_req = null;
        }
    }
}

function updatePreviousVotes(previous)
{
    var arrPrevious = previous.split(";");
    var existingVotes = getCookie(g_cookieName);
    if (existingVotes == null) { existingVotes = ""; }
    var arrVotes = existingVotes.split(";");
    var existingVotesOld = existingVotes;

    var i = 0;
    for (i = 0; i < arrPrevious.length; i++) {
        var j = 0;
        var foundItem = false;

        for (j = 0; j < arrVotes.length; j++) {
            if (arrPrevious[i] == arrVotes[j]) {
                foundItem = true;
                break;
            }
        }

        if (!foundItem) {
            if (existingVotes == "") {
                existingVotes = arrPrevious[i];
            }
            else {
                existingVotes += ";" + arrPrevious[i];
            }
        }

    }

    if (existingVotesOld != existingVotes) {
        setCookie(g_cookieName, existingVotes, 120);
    }
}

function mutltiCheckUpwardedStatus(itemsOnPage)
{
    var arrItemsOnPage = itemsOnPage.split(";");
    var existingVotes = getCookie(g_cookieName);
    if (existingVotes == null) { existingVotes = ""; }
    var arrVotes = existingVotes.split(";");

    var i = 0;
    for (i = 0; i < arrItemsOnPage.length; i++) {
        var j = 0;
        for (j = 0; j < arrVotes.length; j++) {
            if (arrItemsOnPage[i] == arrVotes[j]) {
                setUpwardDisplay(arrVotes[j], "Upwarded");
                break;
            }
        }
    }
}

function setUpwardDisplay(itemId, toDisplay)
{
    var elm = document.getElementById("itemVote" + itemId);
    if (elm) {
        elm.innerHTML = toDisplay;
    }
}

function getCookie(name)
{
    var start = document.cookie.indexOf( name + "=" );
    var len = start + name.length + 1;
    if ( ( !start ) && ( name != document.cookie.substring( 0, name.length ) ) ) {
        return null;
    }
    if ( start == -1 ) return null;
    var end = document.cookie.indexOf( ";", len );
    if ( end == -1 ) end = document.cookie.length;
    return unescape( document.cookie.substring( len, end ) );
}

function setCookie(name, value, expires)
{
    var path = "/";
    var domain = null;
    var secure = null;

    var today = new Date();
    today.setTime( today.getTime() );
    if ( expires ) {
        expires = expires * 1000 * 60 * 60 * 24;
    }
    var expires_date = new Date( today.getTime() + (expires) );
    document.cookie = name+"="+escape( value ) +
        ( ( expires ) ? ";expires="+expires_date.toGMTString() : "" ) + //expires.toGMTString()
        ( ( path ) ? ";path=" + path : "" ) +
        ( ( domain ) ? ";domain=" + domain : "" ) +
        ( ( secure ) ? ";secure" : "" );
}

function deleteCookie(name, path, domain)
{
    if ( getCookie( name ) ) document.cookie = name + "=" +
            ( ( path ) ? ";path=" + path : "") +
            ( ( domain ) ? ";domain=" + domain : "" ) +
            ";expires=Thu, 01-Jan-1970 00:00:01 GMT";
}

function getCachePrevent()
{
    return "&rand=" + escape( Math.round( Math.random() * 10000 ) );
}
