<?

// Upwarded.com source by Philipp Lenssen 2006
// Program provided "as is" without any warranties;
// Use at your own risk.
// Licensed under the GNU GPL CC license:
// http://creativecommons.org/licenses/GPL/2.0/

require_once('lib/misc.php');
require_once('lib/database.php');
require_once('misc.php5');
require_once('lib-rss.php5');
require_once('lib-search.php5');
require_once('lib-ranking.php5');

$g_mode = '';
$g_page = '';
$g_title = '';
$g_url = '';
$g_userName = '';
$g_itemId = '';
$g_commentId = '';
$g_query = '';
$g_content = '';
$g_itemsOnPage = '';
$g_upwardedAt = -1;

$g_upwardedAtDiscover = 0;
$g_upwardedAtFront = 1;
$g_upwardedAtItem = 2;

$g_minChars = 30;
$g_maxChars = 160;

$g_perPage = 20;

if ( isset($_POST['mode']) ) {
    $g_mode = ( isset($_POST['mode']) ) ? $_POST['mode'] : '';
    $g_page = ( isset($_POST['page']) ) ? $_POST['page'] : 1;
    $g_title = ( isset($_POST['title']) ) ? $_POST['title'] : '';
    $g_url = ( isset($_POST['url']) ) ? $_POST['url'] : '';
    $g_userName = ( isset($_POST['userName']) ) ? $_POST['userName'] : '';
    $g_content = ( isset($_POST['content']) ) ? $_POST['content'] : '';
    $g_itemId = ( isset($_POST['itemId']) ) ? $_POST['itemId'] : '';
    defendUnknownParams($_POST);
}
else {
    $g_mode = ( isset($_GET['mode']) ) ? $_GET['mode'] : '';
    if ($g_mode == 'doSubmit') { $g_mode = '404'; }
    $g_page = ( isset($_GET['page']) ) ? $_GET['page'] : 1;
    $g_url = ( isset($_GET['url']) ) ? $_GET['url'] : '';
    $g_title = ( isset($_GET['title']) ) ? $_GET['title'] : '';
    $g_itemId = ( isset($_GET['itemId']) ) ? $_GET['itemId'] : '';
    $g_commentId = ( isset($_GET['commentId']) ) ? $_GET['commentId'] : '';
    $g_query = ( isset($_GET['q']) ) ? $_GET['q'] : '';
    $g_upwardedAt = ( isset($_GET['upwardedAt']) ) ? $_GET['upwardedAt'] : '';
    defendUnknownParams($_GET);
}

$g_mode = stripslashes($g_mode);
$g_page = stripslashes($g_page);
$g_title = stripslashes($g_title);
$g_url = stripslashes($g_url);
$g_itemId = stripslashes($g_itemId);
$g_commentId = stripslashes($g_commentId);
$g_query = stripslashes($g_query);
$g_upwardedAt = stripslashes($g_upwardedAt);

handleAll();

function handleAll()
{
    global $g_mode;
    global $g_page;
    global $g_itemId;
    global $g_commentId;
    global $g_query;
    global $g_userName;
    global $g_content;
    global $g_upwardedAt;

    $db = openDatabase();
    switch ($g_mode)
    {
        case '':
            $title = ($g_page != 1) ? 'Page ' . $g_page : '';
            $title . ' ' . getUpwardedAt();
            showHeader($title);
            showOverview($g_page);
            showFooter();
            break;

        case 'about':
            showHeader('About');
            showAbout();
            updateCalculatedVotes(57);
            showFooter();
            break;

        case 'submit':
            showHeader('Submit');
            showSubmit();
            showFooter();
            break;

        case 'doSubmit':
            showHeader('Submitting');
            showDoSubmit();
            showFooter();
            break;

        case 'submitComment':
            showHeader('Submit Comment');
            showSubmitComment($g_itemId, $g_userName, $g_content);
            showFooter();
            break;

        case 'discover':
            showHeader('Discover');
            showDiscover();
            showFooter();
            break;

        case 'latestComments':
            showHeader('Latest Comments');
            showLatestComments();
            showFooter();
            break;

        case 'getWidget':
            showHeader('Get the Widget');
            showGetWidget();
            showFooter();
            break;

        case 'vote':
            header('Content-type: text/xml; charset=UTF-8');
            @header('Cache-Control: no-cache, must-revalidate'); 
            showVote($g_itemId, $g_upwardedAt);
            break;

        case 'search':
            $title = 'Search results for "' . $g_query . '"';
            showHeader($title, false);
            showSearchResults($g_query, $title, 'title');
            if ( authorExists($g_query) ) {
                showSearchResults($g_query, 'Author ' . ucfirst($g_query), 'userName');
                showLatestComments($g_query);
            }
            showFooter();
            break;

        case 'nickname':
            $title = 'Author ' . ucfirst($g_query);
            showHeader($title, false);
            showAuthorHome($g_query);
            showSearchResults($g_query, $title, 'userName');
            showLatestComments($g_query);
            showFooter();
            break;

        case 'item':
            $itemTitle = getTitleOfId($g_itemId);
            if ($itemTitle == '') {
                showHeader($itemTitle, false, 'HTTP/1.0 404 Not Found');
                sendFileNotFound();
                showFooter();
            }
            else {
                showHeader($itemTitle);
                showItemPage($g_itemId);
                showFooter();
            }
            break;

        case 'deleteItemAsk':
            if ( isAdmin() ) {
                showHeader('Delete item?');
                showDeleteItem($g_itemId, false);
                showFooter();
            }
            break;

        case 'deleteItem':
            if ( isAdmin() ) {
                showHeader('Deleting item');
                showDeleteItem($g_itemId, true);
                showFooter();
            }
            break;

        case 'deleteCommentAsk':
            if ( isAdmin() ) {
                showHeader('Delete comment?');
                showDeleteComment($g_commentId, false);
                showFooter();
            }
            break;

        case 'deleteComment':
            if ( isAdmin() ) {
                showHeader('Deleting comment');
                showDeleteComment($g_commentId, true);
                showFooter();
            }
            break;
        default:
            showHeader($itemTitle, false, 'HTTP/1.0 404 Not Found');
            sendFileNotFound();
            showFooter();
            break;
    }
    closeDatabase($db);
}

function showDeleteItem($itemId, $confirmed = false)
{
    if (!$confirmed) {
        echo '<h2>Delete item?</h2>';
        echo '<p>Do you really want to delete the following item (and all of its comments &amp; votes):</p>';
        echo '<p><strong>' . toXml( getTitleOfId($itemId) ) . '</strong></p>';
        echo '<p><em><a href="/?mode=deleteItem&amp;itemId=' . toAttribute($itemId) . '">Yes</a></em></a>';
    }
    else {
        if ($itemId != '') {
            echo '<h2>Deleting item...</h2>';
            deleteItem($itemId);
            deleteCommentsOfItem($itemId);
            deleteVotesOfItem($itemId);
            $rss = new classRss();
            $rss->update();
            echo '<p>Item deleted.</p>';
        }
    }
}

function showDeleteComment($commentId, $confirmed = false)
{
    if (!$confirmed) {
        echo '<h2>Delete comment?</h2>';
        echo '<p>Do you really want to delete this comment?</p>';
        echo '<p><em><a href="/?mode=deleteComment&amp;commentId=' . toAttribute($commentId) . '">Yes</a></em></a>';
    }
    else {
        if ($commentId != '') {
            echo '<h2>Deleting comment...</h2>';
            deleteComment($commentId);
            $rss = new classRss();
            $rss->update();
            echo '<p>Comment deleted.</p>';
        }
    }
}

function deleteItem($itemId)
{
    $query = 'DELETE FROM up_item WHERE id = ' . smartQuote($itemId) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- ' . deleteItem() . ' -->' );
}

function deleteCommentsOfItem($itemId)
{
    $query = 'DELETE FROM up_comment WHERE itemId = ' . smartQuote($itemId);
    $rows = mysql_query($query) or die( 'Error <!-- ' . deleteCommentsOfItem() . ' -->' );
}

function deleteVotesOfItem($itemId)
{
    $query = 'DELETE FROM up_vote WHERE itemId = ' . smartQuote($itemId);
    $rows = mysql_query($query) or die( 'Error <!-- ' . deleteVotesOfItem() . ' -->' );
}

function deleteComment($commentId)
{
    $itemId = getItemIdOfComment($commentId);
    $query = 'DELETE FROM up_comment WHERE id = ' . smartQuote($commentId) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- ' . deleteComment() . ' -->' );
    updateCalculatedComments($itemId);
}

function getItemIdOfComment($commentId)
{
    $itemId = -1;
    $query = 'SELECT itemId FROM up_comment WHERE id = ' . smartQuote($commentId) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error getItemIdOfComment <!-- ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        $itemId = $c['itemId'];
        break;
    }
    return $itemId;
}

function defendUnknownParams($arr)
{

    global $g_mode;
    $arrOk = array('mode', 'page', 'title', 'rand', 'url', 'userName', 'itemId', 'commentId', 'content', 'itemsOnPage', 'cheat', 'upwardedAt', 'q');
    $allOk = true;
    foreach($arr as $key => $v) {
        if ( !in_array($key, $arrOk) ) {
            $allOk = false;
            break;
        }
    }
    if (!$allOk) { $g_mode = '404'; }
}

function sendFileNotFound()
{
    ?>
    <h2>Document not found</h2>

    <p class="error">Ooops! This URL doesn't exist... <a href="/">here's the homepage</a> though.</p>
    <?
}

function authorExists($userName)
{
    $query = 'SELECT id FROM up_comment WHERE userName = ' . smartQuote($userName) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );

    $query2 = 'SELECT id FROM up_item WHERE userName = ' . smartQuote($userName) . ' LIMIT 1';
    $rows2 = mysql_query($query2) or die( 'Error <!-- ' . mysql_error() . ' -->' );

    return mysql_num_rows($rows) >= 1 || mysql_num_rows($rows2) >= 1;
}

function showSearchResults($q, $title, $field = 'title')
{
    if ($q != '') {
        echo '<h2>' . toXml($title) . '</h2>';
        $q = clarifySearch($q);
        $hiliteArr = array();
        $search = '';
        if ( strpos($q, ' ' ) >= 1 ) {
            $hiliteArr = explode(' ', $q);
            $search = "'%" . join("%' AND " . $field . " LIKE '%", $hiliteArr) . "%'";
        }
        else {
            $search = "'%" . $q . "%'";
            $hiliteArr[0] = $q;
        }

        $query = 'SELECT id, url, title, calculatedVotes, calculatedComments, userName, dateCreated ' .
                'FROM up_item WHERE ' . $field . ' LIKE ' . $search . ' ' .
                'ORDER BY dateCreated DESC LIMIT 30';
        $rows = mysql_query($query) or die( 'Error <!-- showSearchResults ' . mysql_error() . ' -->' );
        while ( $c = mysql_fetch_array($rows) ) {
            showItem($c['id'], $c['url'], $c['title'], $c['calculatedVotes'], $c['calculatedComments'],
                    $c['userName'], $c['dateCreated'], $hiliteArr);
        }

        if ( mysql_num_rows($rows) == 0 ) {
            echo '<p>Found nothing...</p>';
        }    
    }
    else {
        echo '<h2>Results</h2><p>Nothing provided.</p>';
    }
}

function showVote($itemId, $upwardedAt)
{
    if ( !isLocalReferrer() ) {
        sendXmlResponse('False Referrer');
    }
    else if ( didVoteOnItemToday($itemId) ) {
        sendXmlResponse('Already Upwarded');
    }
    else if ( !isUpwardedValue($upwardedAt) ) {
        sendXmlResponse('False value');
    }
    else {
        $dateNow = getIsoDate();
        $ip = getIp();
        $query = 'INSERT INTO up_vote (itemId, userIp, dateCreated, upwardedAt) VALUES (' .
                smartQuote($itemId) . ',' . smartQuote($ip) . ',' . smartQuote($dateNow) . ',' . smartQuote($upwardedAt) . ')';
        $rows = mysql_query($query) or die( 'Error <!-- submitComment ' . mysql_error() . ' -->' );
        updateCalculatedVotes($itemId);
        sendXmlResponse('Upwarded');
    }
}

function updateCalculatedVotes($itemId)
{
    $voteCount = 0;
    $query = 'SELECT COUNT(*) AS voteCount FROM up_vote WHERE itemId = ' . smartQuote($itemId);
    $rows = mysql_query($query) or die( 'Error <!-- updateCalculatedVotes 1 ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        $voteCount = $c['voteCount'];
    }

    $query = 'UPDATE up_item SET calculatedVotes  = ' . smartQuote($voteCount) . ' ' .
            'WHERE id = ' . smartQuote($itemId) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- updateCalculatedVotes 2 ' . mysql_error() . ' -->' );
}

function isUpwardedValue($upwardedAt)
{
    global $g_upwardedAtFront;
    global $g_upwardedAtDiscover;
    global $g_upwardedAtItem;
    return $upwardedAt == $g_upwardedAtFront || $upwardedAt == $g_upwardedAtDiscover || $upwardedAt == $g_upwardedAtItem;
}

function isLocalReferrer()
{
    $ref = getReferrer();
    return $ref == 'http://www.upwarded.com' ||
            strpos($ref, 'http://www.upwarded.com/') == 0 ||
            $ref == 'http://upwarded.com' ||
            strpos($ref, 'http://upwarded.com/') == 0;
}

function didVoteOnItemToday($itemId)
{
    $ip = getIp();
    $query = 'SELECT COUNT(*) AS ipDayCount FROM up_vote WHERE userIp = ' . smartQuote($ip) . ' AND ' .
            'dateCreated LIKE "' . getIsoDay() . ' %" AND itemId = ' . smartQuote($itemId);
    $rows = mysql_query($query) or die( 'Error <!-- didVoteOnItem ' . mysql_error() . ' -->' );

    $ipDayCount = 0;
    while ( $c = mysql_fetch_array($rows) ) {
        $ipDayCount = $c['ipDayCount'];
    }

    return $ipDayCount >= 1;
}

function sendXmlResponse($s)
{
    echo '<' . '?xml version="1.0"?' . '><response>' . toXml($s) . '</response>';
}

function showItemPage($id)
{
    $userName = '';
    $query = 'SELECT id, url, title, calculatedVotes, calculatedComments, userName, dateCreated ' .
            'FROM up_item WHERE id = ' . smartQuote($id) . ' ' .
            'LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        $userName = $c['userName'];
        showItem($c['id'], $c['url'], $c['title'], $c['calculatedVotes'], $c['calculatedComments'],
                $c['userName'], $c['dateCreated']);
        break;
    }

    showComments($id);
    showAuthorHome($userName);
}

function showComments($itemId)
{
    echo '<h3>Comments</h3>';
    $query = 'SELECT id, dateCreated, userName, content FROM up_comment WHERE itemId = ' . smartQuote($itemId) . ' ORDER BY dateCreated ASC';
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        ?>
        <div class="comment">
            <p class="commentContent"><?= getPreparedContent($c['content']) ?></p>
            <? if ( isAdmin() ) { echo '<p><a class="admin" href="/?mode=deleteCommentAsk&amp;commentId=' .
                    toAttribute($c['id']) . '">Delete comment</a></p>'; } ?>
            <p class="commentAuthor"><strong><a href="/?mode=nickname&amp;q=<?= urlencode($c['userName']) ?>">
                <?= toXml($c['userName']) ?></a></strong> &nbsp;<?= howLongAgo($c['dateCreated']) ?></p>
        </div>
        <?
    }

    showPrepareComment($itemId);
}

function showLatestComments($userName = '')
{
    global $g_mode;

    $whereClause = ($userName != '') ? 'WHERE up_comment.userName = ' . smartQuote($userName) . ' ' : '';

    $query = 'SELECT up_comment.dateCreated AS commentDateCreated, up_comment.userName AS commentUserName, ' .
            'up_comment.content AS commentContent, up_comment.itemId AS commentItemId, up_item.title AS itemTitle ' .
            'FROM up_item JOIN up_comment on up_item.id = up_comment.itemId ' . $whereClause .
            'ORDER BY up_comment.dateCreated DESC LIMIT 50';
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );

    $displayedTitle = false;

    while ( $c = mysql_fetch_array($rows) ) {
        if (!$displayedTitle) {
            echo '<h2>Latest comments</h2>';
            $displayedTitle = true;
        }

        ?>
        <p class="commentOn"><strong>Comment on</strong> &nbsp; <?= toXml($c['itemTitle']) ?>
            (<a href="/item/<?= toXml($c['commentItemId']) ?>">View thread</a>)
        </p>
        <div class="comment">
            <p class="commentContent"><?= getPreparedContent($c['commentContent']) ?></p>
            <p class="commentAuthor">
                <strong>
                <? if ($g_mode == 'search' || $g_mode == 'nickname') { ?>
                    <?= toXml($c['commentUserName']) ?>
                <? } else { ?>
                    <a href="/?mode=nickname&amp;q=<?= urlencode($c['commentUserName']) ?>"
                            ><?= toXml($c['commentUserName']) ?></a>
                <? } ?>
                </strong> &nbsp;<?= howLongAgo($c['commentDateCreated']) ?>
            </p>
        </div>
        <?
    }
}

function showAdsenseSmallTextBanner()
{
    // ad code
}

function showAdsenseImageBanner()
{
    // ad code
}

function getPreparedContent($s)
{
    $s = misc_toXml($s);
    $s = tagLinks($s);
    $s = str_replace("\r\n", '<br />', $s);
    $s = str_replace("\r", '<br />', $s);
    $s = str_replace("\n", '<br />', $s);
    $s = str_replace('  ', '&nbsp; ', $s);
    $s = str_replace(' - ', ' -- ', $s);
    $s = str_replace('(C)', '(c)', $s);
    $s = str_replace('(c)', '&copy;', $s);
    $s = str_replace('(TM)', '(tm)', $s);
    $s = str_replace('(tm)', '&trade;', $s);
    $s = str_replace(' -- ', ' &#8211; ', $s);

    return $s;
}

function getPreparedTitle($s)
{
    $s = toXml($s);
    $s = str_replace(' - ', ' -- ', $s);
    $s = str_replace('(C)', '(c)', $s);
    $s = str_replace('(c)', '&copy;', $s);
    $s = str_replace('(TM)', '(tm)', $s);
    $s = str_replace('(tm)', '&trade;', $s);
    $s = str_replace(' -- ', ' &#8211; ', $s);

    return $s;
}



function showPrepareComment($itemId)
{
    ?>
    <form action="/" method="post" class="prepareComment">
        <p>
        <span class="footnote"><strong>Nick name</strong>/ full name:</span><br /><input type="text" class="textInput" name="userName" size="40" id="userName" />
        </p>
        <p><textarea cols="40" rows="6" name="content"></textarea></p>
        </p>
        <p class="submitButton">
            <input type="submit" value="Submit" />
            <input type="hidden" name="itemId" value="<?= toAttribute($itemId) ?>" />
            <input type="hidden" name="mode" value="submitComment" />
        </p>
    </form>
    <?
}

function getTitleOfId($id)
{
    $title = '';
    $query = 'SELECT title FROM up_item WHERE id = ' . smartQuote($id) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        $title = $c['title'];
    }
    return $title;
}

function showDiscover()
{
    global $g_perPage;
    ?>
    <h2>Discover fun links</h2>

    <?
    $query = 'SELECT id, url, title, calculatedVotes, calculatedComments, userName, dateCreated FROM up_item ' .
            'WHERE calculatedScorePos >= ' . smartQuote($g_perPage) . ' OR calculatedScorePos = 0 ' .
            'ORDER BY dateCreated DESC ' .
            'LIMIT 100';
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );

    while ( $c = mysql_fetch_array($rows) ) {
        showItem($c['id'], $c['url'], $c['title'], $c['calculatedVotes'], $c['calculatedComments'], $c['userName'], $c['dateCreated']);
    }

}

function showSubmitComment($itemId, $userName, $content)
{

    $ip = getIp();
    $dateNow = getIsoDate();
    if ($itemId != '')
    {
        if ($userName == '') {
            echo '<p class="error">Ooops! Please go back to provide your nick name.</p>';
        }
        else if ($content == '') {
            echo '<p class="error">Ooops! Please go back to provide a comment.</p>';
        }
        else if ( commentExistsInThread($itemId, $userName, $content) ) {
            echo '<p class="error">Ooops! This comment has already been posted...</p>';
        }
        else {
            $query = 'INSERT INTO up_comment (itemId, userName, content, userIp, dateCreated) VALUES (' .
                    smartQuote($itemId) . ',' . smartQuote($userName) . ',' . smartQuote($content) . ',' .
                    smartQuote($ip) . ',' . smartQuote($dateNow) . ')';
            $rows = mysql_query($query) or die( 'Error <!-- submitComment ' . mysql_error() . ' -->' );
            updateCalculatedComments($itemId);
            echo '<p class="success">Thanks for submitting your comment! &nbsp; <a href="/item/' . toAttribute($itemId) . '">Back to thread</a>...</p>';
        }

        saveUserNameToCookie($userName);
    }
}

function saveUserNameToCookie($userName)
{
    ?>
    <script type="text/javascript"><!--
    setCookie("upwardedUserName", "<?= toAttribute($userName) ?>", 120);
    // --></script>
    <?
}

function updateCalculatedComments($itemId)
{
    $query = 'SELECT COUNT(*) AS commentsCount FROM up_comment WHERE itemId = ' . smartQuote($itemId);
    $rows = mysql_query($query) or die( 'Error <!-- calculateComments select ' . mysql_error() . ' -->' );
    $commentsCount = 0;
    while ( $c = mysql_fetch_array($rows) ) {
        $commentsCount = $c['commentsCount'];
        break;
    }

    $query = 'UPDATE up_item SET calculatedComments = ' . smartQuote($commentsCount) . ' ' .
            'WHERE id = ' . smartQuote($itemId);
    $rows = mysql_query($query) or die( 'Error <!-- calculateComments update ' . mysql_error() . ' -->' );
}

function commentExistsInThread($itemId, $userName, $content)
{
    $query = 'SELECT id FROM up_comment WHERE itemId = ' . smartQuote($itemId) . ' ' .
            'AND userName = ' . smartQuote($userName) . ' AND content = ' . smartQuote($content) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- getIdOfUrl ' . mysql_error() . ' -->' );

    return mysql_num_rows($rows) >= 1;
}

function showSubmit()
{
    global $g_minChars;
    global $g_maxChars;
    global $g_url;
    global $g_title;

    if ($g_url != '' && $g_title != '') {
        echo '<h2>Submit this link if it made you laugh...</h2>';
    }
    else {
        echo '<h2>Submit a link that made you laugh...</h2>';
    }

    ?>
    <form action="/" method="post">
        <p>
            <span class="footnote"><strong>Describe what you link to</strong> &amp; mention the <strong>type of content</strong>
            (video, image, article etc.):
            </span>
            <textarea name="title" rows="2" cols="30"><?= toXml( cutlength($g_title, $g_maxChars) ) ?></textarea>
        </p>
        <p>
            <span class="footnote"><strong>URL</strong>:</span><br />
            <input type="text" class="textInput" name="url" size="60" value="<?= toAttribute($g_url) ?>" />
        </p>
        <p>
            <span class="footnote"><strong>Nick name</strong>/ full name (optional):</span><br />
            <input type="text" class="textInput" name="userName" id="userName" size="60" />
        </p>
        <p class="submitButton">
            <input type="submit" value="Submit" />
            <input type="hidden" name="mode" value="doSubmit" />
        </p>
    </form>
    <?
}

function showDoSubmit()
{
    global $g_minChars;
    global $g_maxChars;
    global $g_title;
    global $g_url;
    global $g_userName;


    if ( isLocalReferrer() )
    {
        $ip = getIp();
    
        $idOfUrl = getIdOfUrl($g_url);
        if ($g_userName == '') { $g_userName = 'Anonymous'; }
    
        if ($g_title == '') {
            echo '<p class="error">Oooops! Please go back to provide a title...</p>';
        }
        else if ($g_url == '') {
            echo '<p class="error">Oooops! Please go back to provide a URL...</p>';
        }
        else if ( !( strpos($g_url, 'http://') === 0 || strpos($g_url, 'https://') === 0 )  ) {
            echo '<p class="error">Oooops! There is something wrong with the URL you provided...</p>';
        }
        else if ( strlen($g_title) < $g_minChars ) {
            echo '<p class="error">Oooops! The title is a bit too short... ' .
                    'please go back to describe your link a little more (you used ' . strlen($g_title) . ', needed are ' .
                    $g_minChars . '+ characters)...</p>';
        }
        else if ( strlen($g_title) > $g_maxChars ) {
            echo '<p class="error">Oooops! The title is too long... ' .
                    'please go back to write a little less (you used ' . strlen($g_title) . ' characters, allowed are ' . $g_maxChars .
                    ' or less)...</p>';
        }
        else if ($idOfUrl != 0) {
            echo '<p class="error">Oooops! This URL exists already... see <a href="/item/' . $idOfUrl . '">this item</a>... </p>';
        }
        else {
            submitItem($g_title, $g_url, $ip, $g_userName);
            $idOfUrl = getIdOfUrl($g_url);
            echo '<p class="success">Thanks for submitting <a href="/item/' . toAttribute($idOfUrl) . '">this link</a>!</p>';
        }
    
        saveUserNameToCookie($g_userName);
    }
}

function submitItem($title, $url, $userIp, $userName)
{
    $dateNow = getIsoDate();
    $query = 'INSERT INTO up_item (title, url, userIp, userName, dateCreated) VALUES (' .
            smartQuote($title) . ',' . smartQuote($url) . ',' . smartQuote($userIp) . ',' . smartQuote($userName) . ',' .
            smartQuote($dateNow) . ')';
    $rows = mysql_query($query) or die( 'Error <!-- submitItem ' . mysql_error() . ' -->' );
}

function getIdOfUrl($url)
{
    $id = 0;
    $query = 'SELECT id FROM up_item WHERE url = ' . smartQuote($url) . ' LIMIT 1';
    $rows = mysql_query($query) or die( 'Error <!-- getIdOfUrl ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        $id = $c['id'];
    }
    return $id;
}

function showGetWidget()
{
    ?>
    <h2>Get the Widget</h2>

    <p>To display the Updwarded Top 3 on your blog or other site, copy &amp; paste the following HTML:</p>

<form><textarea readonly="readonly" onclick="this.focus();this.select()"
    rows="2" cols="40">&lt;script type=&quot;text/javascript&quot; src=&quot;http://upwarded.com/widget/default.js&quot;&gt;&lt;/script&gt;</textarea></form>

    <div class="sampleWidget">
        <p>The dimensions of this widget are 125x200 pixels, and it will show like this:</p>

        <script type="text/javascript" src="http://upwarded.com/widget/default.js"></script>    
    </div>

    <h3>"Upward It" link for your blog</h3>

    <p>And this might be of interest if you have a blog where you post funny stuff yourself &#8211;
    you can use the following syntax to automatically allow your readers to submit/ upward links:</p>
    <pre>http://www.upwarded.com/upwardit/?title=...&url=...</pre>
    <p>(Note that both title and URL parameters need to be correctly URL-encoded.)</p>

    <?
}

function showAbout()
{
    /*
    Un-comment this to force RSS update:
    $rss = new classRss();
    $rss->update();
    */

    ?>
    <h2>About Upwarded</h2>

    <p>At this site, the wisdom of crowds decides which fun links get on top (<a href="http://www.digg.com">digg</a>-style). By clicking on "Upward it" on any link you like,
        you'll push it one step closer to the front-page to be seen by anyone.</p>

    <p>You can submit any fun links you find; videos, games, imagery, quiz games, something from the world of bizarre and interesting that's
        a good time-waster. At Upwarded, participating is easy as you don't need to register.</p>

    <? showTopUsers(); ?>

    <p><strong>A button for you:</strong> &nbsp; <img src="/image/upwarded-button.gif" alt="Upwarded" /></p>

    <p>There have been <?= getItemCount() ?> links submitted until today.</p>

    <p>Got feedback? Please email me, Philipp Lenssen, at
        <a href="mailto:philipp.lenssen@gmail.com?subject=Upwarded">philipp.lenssen@gmail.com</a>.
    </p>

    <h3>Privacy</h3>

    <p>When you submit something, it'll enter the Upwarded database and is going to be published on this site.
    </p>

    <p class="weak footnote">Responsible for this server: Philipp Lenssen, Rudolfstr. 8, 70190 Stuttgart, Germany</p>
    <?
}

function showTopUsers()
{
    $max = 20;

    $query = 'SELECT userName, calculatedVotes FROM up_item ORDER BY userName ASC';
    $rows = mysql_query($query) or die( 'Error <!-- showTopUsers ' . mysql_error() . ' -->' );
    $users = array();
    $usersVote = array();
    while ( $c = mysql_fetch_array($rows) ) {
        $users[ $c['userName'] ] = $users[ $c['userName'] ] + 1;
        $usersVote[ $c['userName'] ] = $usersVote[ $c['userName'] ] + $c['calculatedVotes'];
    }

    arsort($users);
    arsort($usersVote);

    ?>
    <table>
    <tr>
        <th>Top users by submitted links</th>
        <th>Top users by upwards for their links</th>
    </tr>
    <tr>
        <td>
        <ol>
        <?
        $counter = 0;
        foreach ($users as $userName => $itemCount) {
            echo '<li><a href="/?mode=nickname&amp;q=' . urlencode($userName) . '">' .
                    toXml($userName) . '</a> &nbsp;<span class="footnote">(' . toXml($itemCount) . ' links)</span></li>' . "\r";
            if (++$counter > $max) { break; }
        }
        ?>
        </ol>
        </td>
        <td>
        <ol>
        <?
        $counter = 0;
        foreach ($usersVote as $userName => $itemCount) {
            echo '<li><a href="/?mode=nickname&amp;q=' . urlencode($userName) . '">' .
                    toXml($userName) . '</a> &nbsp;<span class="footnote">(' . toXml($itemCount) . ' upwards)</span></li>' . "\r";
            if (++$counter > $max) { break; }
        }
        ?>
        </ol>
        </td>
    </tr>
    </table>
    <?
}

function getItemCount()
{
    $itemCount = 0;
    $query = 'SELECT COUNT(*) AS itemCount FROM up_item';
    $rows = mysql_query($query) or die( 'Error <!-- getItemCount ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        $itemCount = $c['itemCount'];
    }
    return $itemCount;
}

function showOverview($page)
{
    $page = intval($page);
    global $g_perPage;
    $query = 'SELECT id, url, title, calculatedVotes, calculatedComments, userName, dateCreated FROM up_item '.
            'ORDER BY calculatedScore DESC, dateCreated DESC ' .
            'LIMIT ' . smartQuote( ($page - 1) * $g_perPage ) . ',' . smartQuote($g_perPage + 1);
    $rows = mysql_query($query) or die( 'Error <!-- ' . mysql_error() . ' -->' );

    if ($page != 1) {
        echo '<h2>Page ' . $page . '</h2>';
    }

    $counter = 0;
    $hitEnd = false;
    while ( $c = mysql_fetch_array($rows) ) {
        if (++$counter > $g_perPage) {
            $hitEnd = true;
            break;
        }
        showItem($c['id'], $c['url'], $c['title'], $c['calculatedVotes'], $c['calculatedComments'], $c['userName'], $c['dateCreated']);
    }

    if ($hitEnd) {
        echo '<div class="next"><a href="/page/' . toAttribute($page + 1) . '">&gt;&gt;Next</a></div>';
    }
}

function getUpwardedAt()
{
    global $g_upwardedAtDiscover;
    global $g_upwardedAtFront;
    global $g_upwardedAtItem;
    global $g_mode;

    $location = -1;
    switch ($g_mode)
    {
        case '':
            $location = 1;
            break;

        case 'discover':
            $location = 0;
            break;

        case 'item':
            $location = 2;
            break;
    }

    return $location;
}

function showItem($id, $url, $title, $votes, $comments, $userName = '', $dateCreated = '', $hiliteArr = null)
{
    global $g_mode;
    global $g_itemsOnPage;

    if ($g_itemsOnPage == '') {
        $g_itemsOnPage = $id;
    }
    else {
        $g_itemsOnPage .= ';' . $id;
    }

    $titleXml = getPreparedTitle($title);
    if ($hiliteArr != null) {
        $titleXml = hilite($titleXml, $hiliteArr);
    }

    ?>
    <div class="item">
        <div class="itemVotes" id="itemVotes<?= toAttribute($id) ?>"><?= toXml($votes) ?></div>
        <div class="itemVote" id="itemVote<?= toAttribute($id) ?>"><a
                href="javascript:upwardIt(<?= toAttribute($id) ?>,<?= getUpwardedAt() ?>)">Upward it</a></div>
        <div class="itemLink"><a <?= ( ($g_mode != '') ? 'rel="nofollow" ' : '' ) ?>href="<?= toAttribute($url) ?>"><?= $titleXml ?></a>
            <span class="itemUrl">(<?= toXml( getNiceDomain($url) ) ?>)</span>

            <? if ( isAdmin() ) { echo '<br /><a class="admin" href="/?mode=deleteItemAsk&amp;itemId=' . toAttribute($id) . '">Delete item</a>'; } ?>

        </div>
        <div class="itemComments">
            <a href="/item/<?= toAttribute($id) ?>"<?= ($g_mode == 'item') ? ' class="samePageLink"' : '' ?>
                    ><?= toXml($comments) ?> comment<?= ( ($comments != 1) ? 's' : '' ) ?></a>
        </div>

        <div class="itemUser">
        <? if ($g_mode == 'item') { ?>
            <a href="/?mode=nickname&amp;q=<?= urlencode( strtolower($userName) ) ?>"
                    ><?= toXml( cutlength($userName, 25) ) ?></a> <?= howLongAgo($dateCreated) ?>
        <? } else { ?>
            <?= toXml( cutlength($userName, 25) ) ?>
        <? } ?>
        </div>

    </div>
    <?
}
function isAdmin()
{
    return $_SERVER['HTTP_HOST'] == 'private.upwarded.com';
}

function insertCheat()
{
    ?>
        <a style="color: #000;font-size: 80%"
                href="javascript:upwardItCheat(<?= toAttribute($id) ?>,<?= getUpwardedAt() ?>)">Cheat Upward It</a>
    <?
    showScore($id);
}

function showScore($id)
{
    echo '<span style="background-color: #fff; font-size: 80%">';
    echo 'Score: ' . getScoreOfItem($id) . '<br />';
    updateVoteCalculation($id);
    echo '</span>';
}

function getScoreOfItem($id)
{
    $query = 'SELECT calculatedScore FROM up_item WHERE id = ' . smartQuote($id);
    $rows = mysql_query($query) or die( 'Error <!-- getScoreOfItem ' . mysql_error() . ' -->' );

    $score = -1;
    while ( $c = mysql_fetch_array($rows) ) {
        $score = $c['calculatedScore'];
    }

    return $score;
}

function showHeader($title = '', $allowBots = true, $customHeader = '')
{
    global $g_mode;
    global $g_query;

    $title = ($title != '') ? $title . ' - Upwarded': 'Upwarded';

    if ($customHeader != '') {
        header($customHeader);
    } else {
        header('Content-type: text/html; charset=UTF-8');
        @header('Cache-Control: no-cache, must-revalidate'); 
    }

    ?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-strict.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
    <head>
        <title><?= toXml($title) ?></title>
        <link rel="stylesheet" href="/default.css" type="text/css" media="screen,print,projection" />
        <script type="text/javascript" src="/default.js"></script>
        <? if (!$allowBots) { ?>
            <meta name="robots" content="noindex,nofollow,noarchive" />
        <? } ?>
        <link rel="alternate" type="application/rss+xml" title="RSS" href="/rss/latest.xml" />
    </head>
    <body class="body<?= ucfirst( toAttribute($g_mode) ) ?>">

    <div class="page">
        <h1><a href="/"><img src="/image/logo.gif" alt="Upwarded" title="" /></a></h1>
        <div class="tagline">funny videos, images, games &amp; silliness</div>
        <div class="context">
            <a href="/submit"<?= ($g_mode == 'submit') ? ' class="samePageLink"' : '' ?>>submit link</a> &nbsp;&bull;&nbsp;
            <a href="/discover"<?= ($g_mode == 'discover') ? ' class="samePageLink"' : '' ?>>discover links</a>
        </div>

        <div class="search">
            <form action="/" method="get">
            <div>
                <input type="text" class="textInput" name="q" size="15" value="<?= toAttribute($g_query) ?>" />
                <input type="submit" class="submitButton" value="Search" />
                <input type="hidden" name="mode" value="search" />
            </div>
            </form>
        </div>

        <div class="content">
    <?
}

function showFooter()
{
    global $g_mode;
    global $g_itemsOnPage;

    ?>
        <div class="footer">
        <a href="/"<?= ($g_mode == '') ? ' class="samePageLink"' : '' ?>>Upwarded</a> 2006. &nbsp;
        <a href="/about"<?= ($g_mode == 'about') ? ' class="samePageLink"' : '' ?>>About &amp; Stats</a> |
        <a href="/getwidget"<?= ($g_mode == 'getWidget') ? ' class="samePageLink"' : '' ?>>Get widget</a> |
        <a href="/comments"<?= ($g_mode == 'latestComments') ? ' class="samePageLink"' : '' ?>>Latest comments</a> |
        <a href="/rss/latest.xml">RSS</a>
        </div>

        </div>

        <?
        $previousVotes = getPreviousVotes();
        echo '<script type="text/javascript"><!--' . "\r";
        if ($previousVotes != '') { echo 'updatePreviousVotes("' . toAttribute($previousVotes) . '");' . "\r"; }
        if ($g_itemsOnPage != '') { echo 'mutltiCheckUpwardedStatus("' . toAttribute($g_itemsOnPage) . '");' . "\r"; }
        echo 'populateUserName();' . "\r";
        echo '// --></script>';
        ?>

        <div class="ads">
            <? showAdsenseSmallTextBanner(); ?>
            <p>Get the <a href="/getwidget">Upwarded&nbsp;widget</a> for your blog</p>
        </div>

    </div>

    </body>
    </html><?
}

function getPreviousVotes()
{
    $s = '';
    $ip = getIp();

    $query = 'SELECT itemId FROM up_vote WHERE userIp = ' . smartQuote($ip) . ' AND ' .
            'dateCreated LIKE "' . getIsoDay() . ' %"';
    $rows = mysql_query($query) or die( 'Error <!-- previousVotes ' . mysql_error() . ' -->' );

    while ( $c = mysql_fetch_array($rows) ) {
        if ($s != '') { $s .= ';'; }
        $s .= $c['itemId'];
    }

    return $s;
}

function getIsoDay()
{
    $today = getdate();
    $year = $today['year'];
    $mon = pad($today['mon']);
    $mday = pad($today['mday']);
    return "$year-$mon-$mday";
}

function getIsoMonth()
{
    $today = getdate();
    $year = $today['year'];
    $mon = pad($today['mon']);
    return "$year-$mon";
}

function showAuthorHome($userName)
{
    if ($userName != '') {
        $search = new classSearch();
        ?>
        <h3>Related link for <?= toXml( ucfirst($userName) ) ?></h3>
        <p class="relatedLink"><?= $search->getTopResult($userName) ?></p>
        <?
    }
}

?>