<?

function reduceUrl($url, $length = 30)
{
    $url = str_replace('http://', '', $url);
    $url = str_replace('https://', '', $url);
    $urlOld = $url;
    $url = substr($url, 0, $length);
    if ($urlOld != $url) {
        $url .= ' ...';
    }
    return $url;
}

function tagLinks($strOld)
{
    $strOld = str_replace("\r\n", " \r\n ", $strOld);

    $strNew = preg_replace('@(http://[^ ]+)@ei',
         '\'<a class="forumlink" rel="nofollow" href="$1">\' . reduceUrl(\'$1\') . \'</a>\'',
         $strOld);
    $strOld = $strNew;
    $strNew = preg_replace('@(https://[^ ]+)@ei',
         '\'<a class="forumlink" rel="nofollow" href="$1">\' . reduceUrl(\'$1\') . \'</a>\'',
         $strOld);

    $stNew = str_replace(" \r\n ", "\r\n", $strNew);

    return $strNew;
}

function clarifySearch($s)
{
    $s = strtolower($s);
    $abc = 'abcdefghijklmnopqrstuvwxyz0123456789 ';
    $sNew = '';

    for ($i = 0; $i < strlen($s); $i++)
    {
        $letter = substr($s, $i, 1);
        if ( strpos($abc, $letter) === false )
        {
            $letter = '';
        }

        $sNew .= $letter;
    }

    $sNew = trim( repeatedReplace($sNew, '  ', ' ') );
    return $sNew;
}

function hilite($sXml, $hiliteArr)
{
    foreach ($hiliteArr as $hi) {
        $sXml = str_ireplace($hi, '<span class="hilite">' . $hi . '</span>', $sXml);
    }
    return $sXml;
}

function getIp()
{
    global $_SERVER;
    $ip = $_SERVER['REMOTE_ADDR'];
    return $ip;
}

function getGuid()
{
    mt_srand( (double) microtime() * 10000 );
    $charid = strtoupper(md5(uniqid(rand(), true)));
    $hyphen = chr(45);
    $uuid = substr($charid, 0, 8) . $hyphen
           . substr($charid, 8, 4) . $hyphen
           . substr($charid,12, 4) . $hyphen
           . substr($charid,16, 4) . $hyphen
           . substr($charid,20,12);

    return $uuid;
}

function toXml($s)
{
    return misc_toXml($s);
}

function toAttribute($s)
{
    return misc_toAttribute($s);
}

function fileNotFound()
{
    header('Status: 404 Not Found');
    die();
}

function getNiceDomain($url)
{
    $parsed_url = parse_url($url);
    $niceUrl = $parsed_url['host'];
    $niceUrl = str_replace('www.', '', $niceUrl);
    $niceUrl = cutLength($niceUrl);
    return $niceUrl;
}

function cutLength($s, $max = 40)
{
    if ( strlen($s) > $max ) {
        $s = substr($s, 0, $max) . '...';
    }

    return $s;
}

function howLongAgo($dateAgo, $dateNow = '')
{
    if ($dateNow == '') {
        $dateNow = getIsoDate();
    }

    $sDifference = '';
    $isRecent = true;

    $secondsDifference = (int) ( ( strtotime($dateNow) - strtotime($dateAgo) ) );
    $sDifference = $secondsDifference . ' seconds';
    if ($secondsDifference >= 60)
    {
        $minutesDifference = (int) ($secondsDifference / 60);
        $sDifference = $minutesDifference;
        $sDifference .= ($minutesDifference == 1) ? ' minute' : ' minutes';

        if ($minutesDifference >= 60)
        {
            $hoursDifference = (int) ($minutesDifference / 60);
            $sDifference = $hoursDifference;
            $sDifference .= ($hoursDifference == 1) ? ' hour' : ' hours';

            if ($hoursDifference >= 24)
            {
                $isRecent = false;
                $daysDifference = (int) ($hoursDifference / 24);
                $sDifference = $daysDifference;
                $sDifference .= ($daysDifference == 1) ? ' day' : ' days';

                if ($daysDifference >= 30)
                {
                    $monthsDifference = (int) ($daysDifference / 30);
                    $sDifference = $monthsDifference;
                    $sDifference .= ($monthsDifference == 1) ? ' month' : ' months';
                }
            }
        }
    }

    $sDifference .= ' ago';

    if ($isRecent) {
        $sDifference = '<span class="recent">' . $sDifference . '</span>';
    }

    return $sDifference;
}

function repeatedReplace($s, $sFind, $sReplace)
{
    $sOld = '';
    while ($sOld != $s) {
        $sOld = $s;
        $s = str_replace($sFind, $sReplace, $s);
    }
    return $s;
}

function getReferrer()
{
    global $_SERVER;
    return $_SERVER['HTTP_REFERER'];
}

?>